#!/bin/bash
ENODEV=19

if [ ! -e /.blksnap/attached-devices ]; then
	echo "<rapidrecovery-vss> attached-devices file doesn't exist on root fs, skipping attach attempt" > /dev/kmsg
	exit 0
fi

if grep -Fxq "/dev/$1" /.blksnap/attached-devices; then
	/usr/bin/bsctl -i /dev/$1 2>&1 1>/dev/null
	if [ $? -eq $ENODEV ]; then
		/usr/bin/bsctl --attach-to-device /dev/$1
	fi
fi
