/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/gfp.h>
#include <linux/mm_types.h>
#include <linux/types.h>
#include <linux/kernel.h>
#include <linux/bio.h>
#include <linux/blkdev.h>
#include <linux/genhd.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-bio.h"
#include "blksnap-bio-submit.h"
static int z102bbfeafe(struct block_device*bdev,sector_t sector,unsigned char*
buf,uint64_t len,int op){gfp_t gfp_flags=GFP_KERNEL;struct request_queue*q=
bdev_get_queue(bdev);int ret=0;int zaa5dba6cc9;int ze36c619606,z68711b0ffc;
unsigned int z5501e1dbcb;struct bio*bio;void*data_ptr=buf;if(!q){ret=-ENODEV;
z5769993871(bdev,"ERROR: Can not determine request queue for bdev [%d:%d]",MAJOR
(bdev->bd_dev),MINOR(bdev->bd_dev));goto out;}ze36c619606=z68711b0ffc=MIN(len,
BIO_MAX_SIZE);zaa5dba6cc9=z2fea680bb6(ze36c619606,PAGE_SIZE);bio=bio_kmalloc(
gfp_flags,zaa5dba6cc9);if(!bio){ret=-ENOMEM;z5769993871(bdev,
"ERROR: Can not allocate bio(%llu, %llu) with %d segments",sector,len,
zaa5dba6cc9);goto out;}z7dfb21d984(bio,bdev);z9a3aa23558(bio)=sector;while(
z68711b0ffc){struct page*page;unsigned int bytes=PAGE_SIZE;if(bytes>z68711b0ffc)
bytes=z68711b0ffc;z5501e1dbcb=bytes;if(ze36c619606<SECTOR_SIZE)z5501e1dbcb=
SECTOR_SIZE;page=alloc_page(q->bounce_gfp|gfp_flags);if(!page){ret=-ENOMEM;
z5769993871(bdev,
"ERROR: Can not allocate page for bio(%llu, %llu) with %d segments",sector,len,
zaa5dba6cc9);goto z86a9bc394f;}if(op!=z11482db68b){if(bytes<z5501e1dbcb)memset(
page_address(page),0,SECTOR_SIZE);memcpy(page_address(page),data_ptr,bytes);}if(
bio_add_pc_page(q,bio,page,z5501e1dbcb,0)<z5501e1dbcb)break;z68711b0ffc-=
z5501e1dbcb;data_ptr+=z5501e1dbcb;}if(z68711b0ffc>0)ze36c619606-=z68711b0ffc;
z76e5d47b75(bio,op);if(op==z11482db68b){char*buf_ptr=buf;struct bio_vec*bvec;int
 i;if(ze36c619606<SECTOR_SIZE){bvec=bio->bi_io_vec;memcpy(buf_ptr,page_address(
bvec->bv_page),ze36c619606);}else{bio_for_each_segment_all(bvec,bio,i){memcpy(
buf_ptr,page_address(bvec->bv_page),bvec->bv_len);buf_ptr+=bvec->bv_len;}}}ret=
ze36c619606;z86a9bc394f:bio_free_pages(bio);bio_put(bio);out:return ret;}int 
z323d633002(struct block_device*bdev,sector_t start_sect,uint32_t z854f8650ce,
unsigned char*data,int op){int ret=0;int64_t bytes_left=z854f8650ce;while(
bytes_left>0){int z7a775ef162=z102bbfeafe(bdev,start_sect,data+(z854f8650ce-
bytes_left),bytes_left,op);if(z7a775ef162<=0){z5769993871(bdev,
"ERROR: Can not read/write sector %llu",start_sect);ret=(z7a775ef162)?
z7a775ef162:-EIO;break;}bytes_left-=z7a775ef162;if(bytes_left&&(ret%SECTOR_SIZE)
){z5769993871(bdev,"ERROR: Unaligned bio detected to submit!");z5769993871(bdev,
"ERROR(2): bytes_left=%d ret=%d",bytes_left,ret);ret=-EIO;break;}start_sect+=
z7a775ef162>>SECTOR_SHIFT;}return ret;}
