/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/blkdev.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-bio-queue.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-device-utils.h"
#include "blksnap-volume.h"
#include "blksnap-bitmap.h"
#include "blksnap-block.h"
#include "blksnap-data.h"
#include "blksnap-cow-tree.h"
#include "blksnap-bitmap.h"
#include "blksnap-rbtree-foreach.h"
struct z9a6dff1010*z768d3dfb71(struct z4964f1d5f4*volume,sector_t addr){struct 
z9a6dff1010*z607b17d5a3;down_read(&volume->za087258663);z607b17d5a3=zfe2501fe91(
&volume->ze190bba191,addr);up_read(&volume->za087258663);return z607b17d5a3;}
struct z9a6dff1010*zfe2501fe91(struct rb_root*root,sector_t addr){struct rb_node
*node=root->rb_node;while(node){struct z9a6dff1010*this=container_of(node,struct
 z9a6dff1010,rb_node);if(addr<this->addr)node=node->rb_left;else if(addr>this->
addr)node=node->rb_right;else return this;}return NULL;}static struct 
z9a6dff1010*ze5fca9c8b5(struct rb_root*root,struct z9a6dff1010*z607b17d5a3){
struct rb_node**node=&root->rb_node;struct rb_node*parent=NULL;WARN_ON(
zfce2568dba(z607b17d5a3));while(*node){struct z9a6dff1010*this=container_of(*
node,struct z9a6dff1010,rb_node);parent=*node;if(z607b17d5a3->addr<this->addr){
node=&((*node)->rb_left);}else{if(z607b17d5a3->addr>this->addr){node=&((*node)->
rb_right);}else{kfree(z607b17d5a3);return this;}}}D(">>> %llu",blk->addr);
rb_link_node(&z607b17d5a3->rb_node,parent,node);rb_insert_color(&z607b17d5a3->
rb_node,root);return z607b17d5a3;}static struct z9a6dff1010*ze99b67b87b(sector_t
 addr){struct z9a6dff1010*z607b17d5a3;gfp_t gfp_mask=GFP_NOIO;z607b17d5a3=
kzalloc(sizeof(*z607b17d5a3),gfp_mask);if(!z607b17d5a3)return NULL;z607b17d5a3->
addr=addr;z607b17d5a3->committed=false;rwlock_init(&z607b17d5a3->lock);return 
z607b17d5a3;}struct z9a6dff1010*zcdc44c2966(struct z4964f1d5f4*volume,sector_t 
addr){struct z9a6dff1010*z607b17d5a3,*new;down_read(&volume->za087258663);if(
z2b33a5c958(volume,addr,z442071e80a)){zf488054a6c:z607b17d5a3=zfe2501fe91(&
volume->ze190bba191,addr);up_read(&volume->za087258663);BUG_ON(!z607b17d5a3);
return z607b17d5a3;}new=ze99b67b87b(addr);if(!new){z8be79bb9f5(
"ERROR: failed to allocate cow block");up_read(&volume->za087258663);return NULL
;}up_read(&volume->za087258663);down_write(&volume->za087258663);if(z2b33a5c958(
volume,addr,z442071e80a)){downgrade_write(&volume->za087258663);kfree(new);goto 
zf488054a6c;}z607b17d5a3=ze5fca9c8b5(&volume->ze190bba191,new);BUG_ON(
z607b17d5a3!=new);z2dbcf3f6a8(volume,addr,z442071e80a);up_write(&volume->
za087258663);return z607b17d5a3;}static bool z55baada8f7(struct z4964f1d5f4*
volume,struct z9a6dff1010*z607b17d5a3){if(WARN_ON(z2b33a5c958(volume,z607b17d5a3
->addr,IN_FLIGHT)))return false;if(WARN_ON(!z2b33a5c958(volume,z607b17d5a3->addr
,z442071e80a)))z8468609e4a(z607b17d5a3);if(WARN_ON(zfce2568dba(z607b17d5a3)&&!
z2b33a5c958(volume,z607b17d5a3->addr,z8d7ae0fe64)))z8468609e4a(z607b17d5a3);
return true;}int z70ae0dca46(struct z4964f1d5f4*volume){int ret=0;struct rb_root
*root=&volume->ze190bba191;struct rb_node*node;struct rb_node*prev=NULL;
down_write(&volume->za087258663);while((node=rb_first(root))!=NULL){struct 
z9a6dff1010*z607b17d5a3=rb_entry(node,struct z9a6dff1010,rb_node);if(node==prev)
{z8be79bb9f5("%s: BUG rb_tree is broken. %p points to itself",__func__,node);
break;}if(z55baada8f7(volume,z607b17d5a3)){rb_erase(node,root);zba10cc4230(
z607b17d5a3);zca01cbe326(volume,z607b17d5a3->addr,z442071e80a);kfree(z607b17d5a3
);}else{ret=1;}prev=node;}up_write(&volume->za087258663);return ret;}void 
zf9c3861721(struct z4964f1d5f4*volume,struct z9a6dff1010*z607b17d5a3,bool 
inserted){bool has_data=zfce2568dba(z607b17d5a3);bool inflight=z2b33a5c958(
volume,z607b17d5a3->addr,IN_FLIGHT);bool z017afc6a64=z2b33a5c958(volume,
z607b17d5a3->addr,z8d7ae0fe64);bool ze072a6bafa=z2b33a5c958(volume,z607b17d5a3->
addr,z442071e80a);if(!inserted&&z017afc6a64&&!inflight&&!has_data&&volume->disk)
{z0e96e5b5b4(volume,"WARNING: Block %llu failed general sanity check%s",(
unsigned long long)z607b17d5a3->addr,!has_data?" (this is probably okay)":"");
z8468609e4a(z607b17d5a3);}if(has_data&&inserted){z0e96e5b5b4(volume,
"WARNING: Inserted block %llu has data",(unsigned long long)z607b17d5a3->addr);
z8468609e4a(z607b17d5a3);}if(has_data&&inflight){z0e96e5b5b4(volume,
"WARNING: Existing block %llu is in-flight with data",(unsigned long long)
z607b17d5a3->addr);z8468609e4a(z607b17d5a3);}if(!has_data&&ze072a6bafa){
z0e96e5b5b4(volume,
"WARNING: Block %llu is flagged as cow but don't have cow data",(unsigned long 
long)z607b17d5a3->addr);z8468609e4a(z607b17d5a3);}if(has_data&&!ze072a6bafa){
z0e96e5b5b4(volume,
"WARNING: Block %llu has allocated cow but not flagged as cow",(unsigned long 
long)z607b17d5a3->addr);z8468609e4a(z607b17d5a3);}if(has_data&&!z017afc6a64){
z0e96e5b5b4(volume,"WARNING: Block %llu has data but not in next snapshot",(
unsigned long long)z607b17d5a3->addr);z8468609e4a(z607b17d5a3);}}
