/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#ifndef z2ad24a7b27
#define z2ad24a7b27
#include <linux/blkdev.h>
#include <blksnap.h>
#include "blksnap-compat.h"
#include "blksnap-device.h"
#define SECTOR_SHIFT		9
#define PAGE_SHIFT		12
#define zf0d12088d2	(PAGE_SHIFT - SECTOR_SHIFT)
#define z7be15aefe1		(1 << zf0d12088d2)
#define SECTOR_SIZE	 	(1 << SECTOR_SHIFT)
#define zcf2fcf6344		"unknown"
#ifndef BLKSNAP_LOG_PREFIX
#  define BLKSNAP_LOG_PREFIX	za3d9410748
#endif
#ifdef zeca20331c6
#define z2f6928ef62
#define z2b46589a0e
#define z6cc6d049ab
#define zb36d4c4d31
#endif
#ifdef z2f6928ef62
#  define D(fmt, ...)		z8be79bb9f5(fmt, ## __VA_ARGS__)
#else 
#  define D(fmt, ...)		do { } while(0)
#endif 
#ifdef z2b46589a0e
#  define z9e7b9d39c7(fmt, ...)	z8be79bb9f5(fmt, ## __VA_ARGS__)
#else 
#  define z9e7b9d39c7(fmt, ...)	do { } while(0)
#endif
#ifdef z6cc6d049ab
#  define z881e000e61(fmt, ...)	z8be79bb9f5(fmt, ## __VA_ARGS__)
#else 
#  define z881e000e61(fmt, ...)	do { } while(0)
#endif
#ifndef MIN
#define MIN(a, b) (((a) < (b)) ? (a) : (b))
#endif
#ifndef MAX
#define MAX(a, b) (((a) > (b)) ? (a) : (b))
#endif
#ifndef z5e6a2f7636
#define z5e6a2f7636(volume, cond, format, ...)	\
	WARN(cond, "[%d:%d]: " format,		\
	     MAJOR(volume->bdev->bd_dev),	\
	     MINOR(volume->bdev->bd_dev),	\
	     ## __VA_ARGS__)
#endif
#ifndef z7749e224e4
# define z7749e224e4(z545c8a1beb, zca991e0d11)				       \
	if (unlikely(!z545c8a1beb)) {					       \
		WARN(1, #z545c8a1beb " hasn't been allocated, %s()", __func__); \
		return zca991e0d11;					       \
	}
#endif
static inline sector_t z0756660e7b(sector_t addr){return addr&~(z7be15aefe1-1);}
static inline sector_t zc145183281(struct bio*bio){return z0756660e7b(
z9a3aa23558(bio));}static inline bool ze79cbbfa4a(struct z87953c6ebf*map){return
(map->flags&z00cdc8543f);}static inline bool zdc056c7b40(struct z87953c6ebf*map)
{return(map->flags&z6870a00f38);}static inline uint64_t z2fea680bb6(uint64_t 
bytes,uint64_t obj_size){return(bytes/obj_size)+((bytes%obj_size)?1:0);}void 
z8be79bb9f5(const char*fmt,...);void z5769993871(const struct block_device*bdev,
const char*fmt,...);void z0e96e5b5b4(const struct z4964f1d5f4*volume,const char*
fmt,...);static inline int zb1d2e81594(const void*arg,const char*func){if(
unlikely(!arg)){z8be79bb9f5("WARNING: %s: Input parameter isn't allocated",func)
;return 1;}else{return 0;}}struct z9ce59fbd66{sector_t bi_sector;unsigned int 
bi_size;unsigned short bi_idx;struct bio*next;struct z4964f1d5f4*volume;};static
 inline void z273118234a(struct bio*bio,struct z9ce59fbd66*bp){BUG_ON(!bio||!bp)
;D("%s: bio(%p) sector=%lu idx=%d size=%u flags=%lu",__func__,bio,z9a3aa23558(
bio),za0c02211c1(bio),z6b5693e0ab(bio),bio->bi_flags);D(
"%s: bp(%p) sector=%lu idx=%d size=%u",__func__,bp,bp->bi_sector,bp->bi_idx,bp->
bi_size);za0c02211c1(bio)=bp->bi_idx;z6b5693e0ab(bio)=bp->bi_size;z9a3aa23558(
bio)=bp->bi_sector;z04ddf3070e(bio);}static inline void zfc42dd652b(struct bio*
bio,struct z9ce59fbd66*bp){BUG_ON(!bio||!bp);D(
"%s: bio(%p) sector=%lu idx=%d size=%u flags=%lu",__func__,bio,z9a3aa23558(bio),
za0c02211c1(bio),z6b5693e0ab(bio),bio->bi_flags);bp->bi_idx=za0c02211c1(bio);bp
->bi_size=z6b5693e0ab(bio);bp->bi_sector=z9a3aa23558(bio);}static inline 
unsigned int z704d4d74cb(struct bio*bio,sector_t z874adccce4){return(((
z9a3aa23558(bio)+((z6b5693e0ab(bio)-1)>>SECTOR_SHIFT)+z7be15aefe1)&~(z7be15aefe1
-1))-z874adccce4)>>zf0d12088d2;}static inline unsigned int sector_count(unsigned
 int len){return(len>>SECTOR_SHIFT)+((len%SECTOR_SIZE)?1:0);}
#endif 

