/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <asm-generic/errno-base.h>
#include <linux/kernel.h>
#include <linux/vmalloc.h>
#include <linux/blkdev.h>
#include <linux/cryptohash.h>
#include <linux/string.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
static inline uint32_t z9671cb08cd(uint64_t len){return round_up(len+sizeof(
__be64)+1,z8aa71ba5b5);}int z48f3a5f993(const u8*data,uint64_t len,u32*out){
const uint32_t zbacc2edbfe=z8aa71ba5b5-sizeof(__be64);uint32_t digest[
z276fc3bfd3];uint32_t ws[zeb4c1f77fc];uint64_t z889f0dcde7=z9671cb08cd(len);
uint64_t aligned_size,blocks,data_size=len;uint8_t*msg,*za0c5642a41;__be64*
z18fbac6ae3;__be32*z01a55044b3;int i;msg=vmalloc(z889f0dcde7);if(!msg)return-
ENOMEM;zb4a569315f(digest);memset(ws,0,z86f2b3aad8);memcpy(msg,data,data_size);
memset(&msg[data_size],0,z889f0dcde7-data_size);msg[data_size++]=0x80;
aligned_size=round_up(data_size,z8aa71ba5b5);blocks=aligned_size/z8aa71ba5b5;
za0c5642a41=msg;z18fbac6ae3=(__be64*)(za0c5642a41+aligned_size-sizeof(__be64));
if(aligned_size-data_size<sizeof(__be64)){z18fbac6ae3=(__be64*)(za0c5642a41+
aligned_size+zbacc2edbfe);blocks++;}*z18fbac6ae3=cpu_to_be64((data_size-1)<<3);
while(blocks--){sha_transform(digest,za0c5642a41,ws);za0c5642a41+=z8aa71ba5b5;}
z01a55044b3=(__force __be32*)digest;for(i=0;i<z276fc3bfd3;i++)z01a55044b3[i]=
cpu_to_be32(digest[i]);memcpy(out,z01a55044b3,sizeof(digest));vfree(msg);return 
0;}
