/*
 * Copyright 2018 - Quest Software Inc.
 * 
 */
 

#include <linux/kernel.h>
#include <linux/types.h>
#include <linux/blkdev.h>
#include "blksnap.h"
#include "blksnap-bio-queue-share.h"
#include "blksnap-hash.h"
#include "blksnap-device.h"
#include "blksnap-compat.h"
#include "blksnap-shared.h"
#include "blksnap-device-utils.h"
#include "blksnap-volume.h"
LIST_HEAD(z5c61784474);struct z4964f1d5f4*z2ee27eb651(struct block_device*bdev){
struct list_head*p,*q;if(zb1d2e81594(bdev,__func__))return NULL;
list_for_each_safe(p,q,&z5c61784474){struct z4964f1d5f4*volume=list_entry(p,
struct z4964f1d5f4,z1f72606673);if(volume->bdev->bd_dev==bdev->bd_dev)return 
volume;}return NULL;}struct z4964f1d5f4*z17ef5db9c9(const char*path){struct 
block_device*bdev;bdev=z0bf5aa5055(path);if(IS_ERR(bdev))return NULL;return 
z2ee27eb651(bdev);}bool z892e1e573c(struct z4964f1d5f4*volume,sector_t addr){if(
WARN_ONCE(!volume->bdev,"volume went missing"))return false;return(
get_start_sect(volume->bdev)<=addr&&(get_start_sect(volume->bdev)+z6a26d8d1a5(
volume->bdev)>addr))?true:false;}struct z4964f1d5f4*z90c0a440b9(struct 
z3fc80aee23*bd,sector_t addr){struct list_head*p,*q;list_for_each_safe(p,q,&bd->
volumes){struct z4964f1d5f4*volume=list_entry(p,struct z4964f1d5f4,siblings);if(
z892e1e573c(volume,addr))return volume;}return NULL;}struct super_block*
z2c0cb1aa81(struct z4964f1d5f4*volume){volume->z95b6672f14=freeze_bdev(volume->
bdev);return volume->z95b6672f14;}int ze9c7b9d72d(struct z4964f1d5f4*volume){
z3129c2eb7b;z9014c013e6 thaw_bdev(volume->bdev,volume->z95b6672f14);return 
z6b2616ddab;}
